#include <memory>
#include <iostream>
#include <cstdlib>
#include <cstring>

using namespace std;

void waitKey(void)
{
  char c;
  cin.read(&c, 1);
}

int main(int argc, char **argv)
{
  if(argc!=1+1)
  {
    cerr << argv[0] << " <size_in_mb>" << endl;
    return 1;
  }

  constexpr size_t mb    = 1024*1024;
  const size_t     count = atoi(argv[1]);
  const size_t     size  = count*mb;
  cout << "allocating " << count << "MB of memory" << endl;
  unique_ptr<char[]> mem( new char[size] );
  bzero(mem.get(), size);
  cout << "done - press enter to continue" << endl;
  waitKey();
  cout << "deallocating and exiting now" << endl;

  return mem.get()[size-1]?42:0;
}
