#include <memory>
#include <vector>
#include <utility>
#include <iostream>
#include <cstdlib>
#include <cstring>

using namespace std;

void waitKey(void)
{
  char c;
  cin.read(&c, 1);
}

int main(int argc, char **argv)
{
  if(argc!=1+1)
  {
    cerr << argv[0] << " <size_in_mb>" << endl;
    return 1;
  }

  typedef unique_ptr<char[]> MemBlock;
  typedef vector<MemBlock>   MemPool;

  constexpr size_t mb    = 1024*1024;
  const size_t     count = atoi(argv[1]);

  cout << "allocating " << count << "MB of memory" << endl;
  MemPool mp;
  mp.reserve(count);
  for(size_t i=0; i<count; ++i)
  {
    MemBlock tmp{ new char[mb] };
    bzero(tmp.get(), mb);
    mp.push_back( std::move(tmp) );
  }
  cout << "done - press enter to continue" << endl;
  waitKey();
  cout << "deallocating and exiting now" << endl;

  return (*mp.rbegin())[mb-1]?42:0;
}
